# coding: utf-8

"""
    mzTab-M reference implementation and validation API.

    This is the mzTab-M reference implementation and validation API service.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: nils.hoffmann@isas.de
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from openapi_client.configuration import Configuration


class Database(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'param': 'Parameter',
        'prefix': 'str',
        'version': 'str',
        'uri': 'str'
    }

    attribute_map = {
        'id': 'id',
        'param': 'param',
        'prefix': 'prefix',
        'version': 'version',
        'uri': 'uri'
    }

    def __init__(self, id=None, param=None, prefix='null', version=None, uri=None, local_vars_configuration=None):  # noqa: E501
        """Database - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._param = None
        self._prefix = None
        self._version = None
        self._uri = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.param = param
        self.prefix = prefix
        self.version = version
        self.uri = uri

    @property
    def id(self):
        """Gets the id of this Database.  # noqa: E501


        :return: The id of this Database.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Database.


        :param id: The id of this Database.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                id is not None and id < 1):  # noqa: E501
            raise ValueError("Invalid value for `id`, must be a value greater than or equal to `1`")  # noqa: E501

        self._id = id

    @property
    def param(self):
        """Gets the param of this Database.  # noqa: E501


        :return: The param of this Database.  # noqa: E501
        :rtype: Parameter
        """
        return self._param

    @param.setter
    def param(self, param):
        """Sets the param of this Database.


        :param param: The param of this Database.  # noqa: E501
        :type: Parameter
        """
        if self.local_vars_configuration.client_side_validation and param is None:  # noqa: E501
            raise ValueError("Invalid value for `param`, must not be `None`")  # noqa: E501

        self._param = param

    @property
    def prefix(self):
        """Gets the prefix of this Database.  # noqa: E501

        The database prefix.  # noqa: E501

        :return: The prefix of this Database.  # noqa: E501
        :rtype: str
        """
        return self._prefix

    @prefix.setter
    def prefix(self, prefix):
        """Sets the prefix of this Database.

        The database prefix.  # noqa: E501

        :param prefix: The prefix of this Database.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and prefix is None:  # noqa: E501
            raise ValueError("Invalid value for `prefix`, must not be `None`")  # noqa: E501

        self._prefix = prefix

    @property
    def version(self):
        """Gets the version of this Database.  # noqa: E501

        The database version.  # noqa: E501

        :return: The version of this Database.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Database.

        The database version.  # noqa: E501

        :param version: The version of this Database.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and version is None:  # noqa: E501
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def uri(self):
        """Gets the uri of this Database.  # noqa: E501

        The URI to the online database.  # noqa: E501

        :return: The uri of this Database.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this Database.

        The URI to the online database.  # noqa: E501

        :param uri: The uri of this Database.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and uri is None:  # noqa: E501
            raise ValueError("Invalid value for `uri`, must not be `None`")  # noqa: E501

        self._uri = uri

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Database):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Database):
            return True

        return self.to_dict() != other.to_dict()
